using System.Activities.Presentation.Metadata;
using System.ComponentModel;
using System.ComponentModel.Design;
using Company.Product.Activities.Design.Designers;
using Company.Product.Activities.Design.Properties;

namespace Company.Product.Activities.Design
{
    public class DesignerMetadata : IRegisterMetadata
    {
        public void Register()
        {
            var builder = new AttributeTableBuilder();
            builder.ValidateTable();

            var categoryAttribute = new CategoryAttribute($"{Resources.Category}");

            builder.AddCustomAttributes(typeof(Simple), categoryAttribute);
            builder.AddCustomAttributes(typeof(Simple), new DesignerAttribute(typeof(SimpleDesigner)));
            builder.AddCustomAttributes(typeof(Simple), new HelpKeywordAttribute(""));


            MetadataStore.AddAttributeTable(builder.CreateTable());
        }
    }
}
