using System;
using System.Activities;
using System.Threading;
using System.Threading.Tasks;
using Company.Product.Activities.Properties;
using UiPath.Shared.Activities;
using UiPath.Shared.Activities.Localization;

namespace Company.Product.Activities
{
    [LocalizedDisplayName(nameof(Resources.Simple_DisplayName))]
    [LocalizedDescription(nameof(Resources.Simple_Description))]
    public class Simple : ContinuableAsyncCodeActivity
    {
        #region Properties

        /// <summary>
        /// If set, continue executing the remaining activities even if the current activity has failed.
        /// </summary>
        [LocalizedCategory(nameof(Resources.Common_Category))]
        [LocalizedDisplayName(nameof(Resources.ContinueOnError_DisplayName))]
        [LocalizedDescription(nameof(Resources.ContinueOnError_Description))]
        public override InArgument<bool> ContinueOnError { get; set; }

        [LocalizedDisplayName(nameof(Resources.Simple_Number1_DisplayName))]
        [LocalizedDescription(nameof(Resources.Simple_Number1_Description))]
        [LocalizedCategory(nameof(Resources.Input_Category))]
        public InArgument<int> Number1 { get; set; }

        [LocalizedDisplayName(nameof(Resources.Simple_Number2_DisplayName))]
        [LocalizedDescription(nameof(Resources.Simple_Number2_Description))]
        [LocalizedCategory(nameof(Resources.Input_Category))]
        public InArgument<int> Number2 { get; set; }

        #endregion


        #region Constructors

        public Simple()
        {
        }

        #endregion


        #region Protected Methods

        protected override void CacheMetadata(CodeActivityMetadata metadata)
        {
            if (Number1 == null) metadata.AddValidationError(string.Format(Resources.ValidationValue_Error, nameof(Number1)));
            if (Number2 == null) metadata.AddValidationError(string.Format(Resources.ValidationValue_Error, nameof(Number2)));

            base.CacheMetadata(metadata);
        }

        protected override async Task<Action<AsyncCodeActivityContext>> ExecuteAsync(AsyncCodeActivityContext context, CancellationToken cancellationToken)
        {
            // Inputs
            var number1 = Number1.Get(context);
            var number2 = Number2.Get(context);
    
            ///////////////////////////
            // Add execution logic HERE
            ///////////////////////////

            // Outputs
            return (ctx) => {
            };
        }

        #endregion
    }
}

